#ifndef __JABYENGINE__H__
#define __JABYENGINE__H__
#include "../stdint.h"

namespace JabyEngine {
    struct NextRoutine {
        typedef NextRoutine (*ExecutionFunction)();

        uintptr_t value;

        static NextRoutine null() {
            return {.value = 0};
        }

        static NextRoutine from(ExecutionFunction function) {
            return {.value = reinterpret_cast<uintptr_t>(function)};
        }
    };

    typedef NextRoutine::ExecutionFunction ExecutionFunction;
}

#endif //!__JABYENGINE__H__